<template>
  <el-container>
    <el-header height="60px" class="content-header">
      <MyHeader
        :title="'统一接入配置'"
        :formData="headerFormData"
        @submit="handleHeaderFormSubmit"
      ></MyHeader>
    </el-header>
    <el-container>
      <el-main>
        <MyTableHeader
          :title="tableHeaderTitle"
          :tabs="tabs"
          :buttons="buttons"
          @tabClick="handleTabClick"
          @buttonClick="handleButtonClick"
        ></MyTableHeader>

        <MyTable
          :tableData="tableData"
          :formData="formData"
          :minWidth="340"
          ref="myTableRef"
          @selection-change="handleSelectionChange"
        >
          <!-- 自定义操作按钮，传递 row 和 index -->
          <template #operation="{ row, index }">
            <el-button
              size="mini"
              @click="handleView(row, 'view')"
              type="primary"
              >查看</el-button
            >
            <el-button
              size="mini"
              @click="handleEdit(row, 'edit')"
              type="primary"
              >编辑</el-button
            >
            <el-button
              v-if="row.status === 0"
              size="mini"
              @click="handleStart(row, index)"
              type="primary"
              >启用</el-button
            >
            <el-button
              v-if="row.status === 1"
              size="mini"
              @click="handleStop(row, index)"
              type="primary"
              >停用</el-button
            >
            <el-button size="mini" @click="handleDelete(row)" type="primary"
              >删除</el-button
            >
          </template>
        </MyTable>
        <MyPagination
          :total="tableTotal"
          :page-size="pageSize"
          :current-page="currentPage"
          @pageChange="pagi_changePage"
          @sizeChange="pagi_changeSize"
        ></MyPagination>
      </el-main>
    </el-container>

    <div v-if="showDialog">
      <ConfigDialog
        v-model="showDialog"
        :title="title"
        :rowObj="rowObj"
        @confirm="getList"
        @before-close=""
      ></ConfigDialog>
    </div>
  </el-container>
</template>
<script>
import {
  getTabAccessConfigList,
  addTabAccessConfig,
  updateTabAccessConfigById,
  viewTabAccessConfigById,
  delTabAccessConfigById,
  exportTabAccessConfig,
} from "@/api/unified-access/access-config";
import MyHeader from "@/components/MyHeader";
import MyTable from "@/components/MyTable";
import MyPagination from "@/components/MyPagination";
import MyTableHeader from "@/components/MyTableHeader";
import ConfigDialog from "./dialog/ConfigDialog.vue";
export default {
  name: "access-config",
  components: {
    MyHeader,
    MyTableHeader,
    MyTable,
    MyPagination,
    ConfigDialog,
  },
  data() {
    return {
      showDialog: false,
      title: "新增",
      rowObj: {},
      type: "add",
      tableData: [],
      formData: [
        {
          label: "接入方式",
          fieldName: "dataManner",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
        {
          label: "网关IP",
          fieldName: "gatewayIp",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
        {
          label: "网关端口",
          fieldName: "gatewayPort",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
        {
          label: "六统一IP",
          fieldName: "sixIp",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
        {
          label: "六统一端口",
          fieldName: "sixPort",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
        {
          label: "数据源所属信息系统",
          fieldName: "offerSystem",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },

        {
          label: "接收方所属信息系统",
          fieldName: "receptionSystem",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
        {
          label: "数据项目",
          fieldName: "dataDetail",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
        {
          label: "拟正式运行时间",
          fieldName: "runTime",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },

        {
          label: "状态",
          fieldName: "status",
          type: "input",
          showInTable: true,
          value: "",
          width: "",
        },
      ],
      tableTotal: 0,
      pageSize: 10,
      currentPage: 1,
      selectedRows: [], // 存储选中的行数据
      searchForm: {},
      treeSearchVal: "",
      tableHeaderTitle: "项目列表",
      tabs: [],
      buttons: [
        {
          label: "新增",
          type: "primary",
          methodName: "action1",
          icon: "el-icon-circle-plus",
        },
        {
          label: "导出",
          type: "primary",
          methodName: "action2",
          icon: "el-icon-upload",
        },
      ],

      headerFormData: [
        {
          label: "接入方式",
          fieldName: "dataManner",
          type: "input",
          value: "",
          placeholder: "请输入接入方式",
          // isRequired: true,
        },
        {
          fieldName: "status",
          label: "状态",
          type: "select",
          trigger: "change",
          value: "",
          isRequired: false,
          options: [
            { value: 1, label: "正常" },
            { value: 0, label: "停用" },
          ],
        },
        // {
        //   label: "用户状态",
        //   fieldName: "gender",
        //   type: "select",
        //   value: "",
        //   placeholder: "请选择用户状态",
        //   isRequired: true,
        //   options: [
        //     { label: "男", value: "male" },
        //     { label: "女", value: "female" },
        //   ],
        // },
        // {
        //   label: "生日",
        //   fieldName: "birthdate",
        //   type: "date",
        //   value: "",
        //   placeholder: "请选择生日",
        //   isRequired: false,
        // },
      ],
    };
  },

  methods: {
    // 头部搜索框
    handleHeaderFormSubmit(form) {
      this.searchForm = form;
      this.getList();
    },
    // 树结构点击
    handleNodeClick() {},
    // 列表头部
    handleTabClick(tab) {
      this.tabs.forEach((item) => {
        if (item.label === tab.label) {
          item.active = true;
        } else {
          item.active = false;
        }
      });
    },
    // 列表头部功能按钮
    handleButtonClick(methodName) {
      console.log(methodName, "methodName");

      switch (methodName) {
        case "action1":
          // 新增
          this.rowObj = {};
          this.title = "新增";
          this.showDialog = true;
          break;
        case "action2":
          // 导出
          if (this.selectedRows.length > 0) {
            // exportTabAccessConfig().then((res) => {
            //   if (+res.code === 200) {
            //   }
            // });
            let ids = [];
            ids = this.selectedRows.map((item) => item.id);
            this.download(
              "/web/tab-access-config/export",
              {
                ids,
              },
              `统一接入配置_${new Date().getTime()}.xlsx`
            );
          } else {
            this.$confirm("请选择列表项?", "提示", {
              confirmButtonText: "关闭",
              cancelButtonText: "取消",
              showCancelButton: false,
              showConfirmButton: false,
              type: "warning",
              center: true,
            })
              .then(() => {})
              .catch(() => {});
          }
          break;

        default:
          break;
      }
    },
    // 处理选中项变化
    handleSelectionChange(selectedRows) {
      this.selectedRows = selectedRows; // 获取选中的行
    },

    getList() {
      getTabAccessConfigList({
        pageNum: this.currentPage,
        pageSize: this.pageSize,
        ...this.searchForm,
      }).then((res) => {
        if (+res.code === 200) {
          this.tableData = res.rows;
          this.tableTotal = +res.total;
        }
      });
    },
    // 列表分页
    pagi_changePage(page) {
      this.currentPage = page;
      this.getList();
    },
    pagi_changeSize(size) {
      this.pageSize = size;
      this.getList();
    },

    // 弹窗
    handleConfirm() {
      this.dialogVisible = true;
    },
    handleClose() {
      this.dialogVisible = false;
    },

    // 编辑
    handleView(row) {
      this.rowObj = row;
      this.title = "查看";
      this.showDialog = true;
    },
    handleEdit(row) {
      console.log(row, "row");
      this.rowObj = row;
      this.title = "编辑";
      this.showDialog = true;
    },

    beforeClose() {
      this.showDialog = false;
    },

    handleStart(row) {
      let pForm = {};
      pForm = { ...row };
      pForm.status = 1;
      updateTabAccessConfigById({ ...pForm }).then((res) => {
        if (+res.code === 200) {
          this.$message({
            message: res.msg,
            type: "success",
          });
          this.getList();
        } else {
          this.$message.error(res.msg);
        }
      });
    },
    handleStop(row) {
      let pForm = {};
      pForm = { ...row };
      pForm.status = 0;
      updateTabAccessConfigById({ ...pForm }).then((res) => {
        if (+res.code === 200) {
          this.$message({
            message: res.msg,
            type: "success",
          });
          this.getList();
        } else {
          this.$message.error(res.msg);
        }
      });
    },
    handleDelete(row) {
      this.$confirm("此操作将永久删除该文件, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        center: true,
        type: "warning",
      })
        .then(() => {
          delTabAccessConfigById(row.id).then((res) => {
            if (+res.code === 200) {
              this.$message({
                message: res.msg,
                type: "success",
              });
              this.getList();
            } else {
              this.$message.error(res.msg);
            }
          });
        })
        .catch(() => {
          this.$message({
            type: "info",
            message: "已取消删除",
          });
        });
      console.log(row, "row");
    },
  },
  created() {},
  mounted() {
    console.log("接入配置");
    this.getList();
  },
};
</script>
<style lang="scss" scoped>
.el-main {
  padding: 0 20px;
}

.el-icon-search {
  font-size: 16px;
  font-weight: 700;
  color: #1e80e0;
}
</style>
